(require 'mirror-url)

;; manipulating file names

(defun mfs-expand-file-name (url default) url)


(defun mfs-file-name-directory (url)
  (let ((url-obj (cg-parse-url url)))
    (cgurl-set-path url-obj (file-name-directory (cgurl-path url-obj)))
    (cgurl-url url-obj)))


(defun mfs-file-name-nondirectory (url)
  (file-name-nondirectory (cgurl-path (cg-parse-url url))))


(defun mfs-file-name-sans-versions (url &optional keep-backup)
  (let ((url-obj (cg-parse-url url)))
    (cgurl-set-vrsn url-obj nil)
    (cgurl-url url-obj)))


(defun mfs-file-name-as-directory (url)
  (let ((url-obj (cg-parse-url url)))
    (cgurl-set-path url-obj
		    (file-name-as-directory (cgurl-path url-obj)))
    (cgurl-url url-obj)))


(defun mfs-directory-file-name (url)
  (let* ((url-obj (cg-parse-url url))
	 (path (cgurl-path url-obj)))
    (cgurl-url (cgurl-set-path url-obj (directory-file-name path)))))


;;; hook into efs
(put 'expand-file-name 'mfs 'mfs-expand-file-name)
(put 'file-name-directory 'mfs 'mfs-file-name-directory)
(put 'file-name-nondirectory 'mfs 'mfs-file-name-nondirectory)
(put 'file-name-as-directory 'mfs 'mfs-file-name-as-directory)
(put 'directory-file-name 'mfs 'mfs-directory-file-name)
(put 'file-name-sans-versions 'mfs 'mfs-file-name-sans-versions)
(put 'unhandled-file-name-directory 'mfs 'mfs-unhandled-file-name-directory)
(put 'diff-latest-backup-file 'mfs 'mfs-diff-latest-backup-file)
(put 'file-truename 'mfs 'mfs-idem)

; unused hooks...
; (put 'abbreviate-file-name 'mfs 'mfs-abbreviate-file-name)

;; file name completion
(put 'file-name-completion 'mfs 'mfs-file-name-completion)
(put 'file-name-all-completions 'mfs 'mfs-file-name-all-completions)

(put 'substitute-in-file-name 'mfs 'mfs-idem)

(provide 'mfs-file-names)