(require 'mirror-url)

;; file properties

(defun mfs-file-directory-p (url)
  (let* ((murl (mirror-parse-url url))
	 (local (mirror-local-name murl)))
    (if (file-exists-p local)
	(file-directory-p local)
      ;; FIXME: stubbly
      nil
      )))


(defun mfs-file-attributes (url)
  (and (mfs-file-exists-p url)
       (let* ((murl (mirror-parse-url url))
	      (local (mirror-local-name url)))
	 (if (not (file-exists-p local))
	     (mirror-copy-file url local))
	 (file-attributes local))))


(defun mfs-file-exists-p (url)
  (let* ((murl (mirror-parse-url url))
	 (local (mirror-local-name url)))
    (or (file-exists-p local)
	(let ((r (mirror-copy-file url local)))
	  (equal 0 r))
	)))
	  
  

;; hook into efs
(put 'file-directory-p 'mfs 'mfs-file-directory-p)
(put 'file-writable-p 'mfs 'mfs-true)
(put 'file-readable-p 'mfs 'mfs-file-readable-p)
(put 'file-executable-p 'mfs 'mfs-file-executable-p)
(put 'file-symlink-p 'mfs 'mfs-false)
(put 'file-attributes 'mfs 'mfs-file-attributes)
(put 'file-exists-p 'mfs 'mfs-file-exists-p)
(put 'file-accessible-directory-p 'mfs 'mfs-file-accessible-directory-p)
(put 'vc-registered 'mfs 'mfs-false)

(provide 'mfs-file-props)
