(defun mfs-make-directory (url &optional parents)
  (let ((url-obj (cg-parse-url url)))
    (cgurl-set-op url-obj "create")
    (cg-rmi-url url-obj
		'((content-type "x-cryptognome/collection")))
    (let ((collection (cg-temp-buffer)))
      (save-excursion (set-buffer collection) (insert "\"()\""))
      (cgurl-set-op url-obj "put")
      (cg-rmi-url url-obj nil collection))))
      

;; creating and removing files
(put 'delete-file 'mfs 'mfs-spew)
(put 'copy-file 'mfs 'mfs-copy-file)
(put 'rename-file 'mfs 'mfs-rename-file)
(put 'file-local-copy 'mfs 'mfs-file-local-copy)
(put 'make-directory-internal 'mfs 'mfs-make-directory)
(put 'delete-directory 'mfs 'mfs-delete-directory)
(put 'add-name-to-file 'mfs 'mfs-add-name-to-file)
; (put 'make-symbolic-link 'mfs 'mfs-make-symbolic-link)

(provide 'mfs-file)