(require 'mirror-url)

(defun mfs-insert-file-contents (url &optional visit beg end replace)
  ; not clear that this should be uncond, but find-file 
  ; won't work for a new file w/out it
  (setq buffer-file-name url) 

  (let* ((url-obj (mirror-parse-url url))
	 (local (mirror-local-name url-obj)))
    (and (not (file-exists-p local))
	 (progn
	   (mirror-make-mirror-dir url-obj)
	   (mirror-copy-file url local)))
    (insert-file-contents local visit beg end replace)))


(defun mfs-write-region
  (beg end url &optional append visit lockname coding-system)
  (let* ((url-obj (mirror-parse-url url))
	 (local (mirror-local-name url-obj)))
    (mirror-make-dir url-obj)
    (write-region beg end local append visit lockname coding-system)))


(defun mfs-insert-directory (url switches &optional wild full)
  (cond ((string-match "d" switches)
	 (mfs-show-dired-metadata url))

	((and (not wild)
	      full
	      (string-match "l" switches))
	 (mfs-list-collection url))

	(t (ding)
	   (message "Unimplemented mfs-insert-directory case: %s %s %s"
		    switches wild full))))



(put 'insert-file-contents 'mfs 'mfs-insert-file-contents)
(put 'write-region 'mfs 'mfs-write-region)
(put 'directory-files 'mfs 'mfs-directory-files)
(put 'list-directory 'mfs 'mfs-list-directory)
(put 'insert-directory 'mfs 'mfs-insert-directory)
; (put 'recover-file 'mfs 'mfs-recover-file)

(provide 'mfs-io)