(require 'mirror-url)
(require 'mirror-net)

(defun mirror-xlate-url (url)
  (if (stringp url)
      (cond ((equal 0 (string-match "url:" url))
	     (substring url 4))
	    ((equal 0 (string-match mirror-type-regexp url))
	     (murl-canonical (mirror-parse-url url)))
	    (t url))))


(defun mirror-guess-host (args)
  (if (null args) (mirror-get-host)
    (let ((arg (car args))
	  (maybe-host
	   (and (stringp arg)
		(let* ((murl (mirror-parse-url arg))
		       (type (murl-type murl)))
		  (and type
		       (murl-host murl)))
		)))
      (or maybe-host 
	  (mirror-guess-host (cdr args)))
      )))


(defun mirror-remote-exec (command &rest args)
  "Treat the remote system as a FS 'metaserver'.

IOW, we open a connection to a shell on the remote, and only count
on a limited set of POSIX commands to be present. Specifically, we
need `ls' and `rm' as that is all that is needed to implement the
Emacs file primitives.

More on this topic at mirror-get-connection"
  (let* ((remote-args (mapcar 'mirror-xlate-url args))
	 (host (mirror-guess-host args))
	 (cxn (mirror-get-connection host)))
    (and cxn
	 (mirror-net-send cxn (apply concat command args)))
    ))

(provide 'mirror-exec)