(require 'mirror-url)

;;; user vars
(defvar mirror-host-connection-params
  '(
    (("cryptognome.sourceforge.net" "cryptognome")
     (remote-command-line 'rsh-connect)
     (remote-user "kumo")
     (rsh-program "ssh"))

    (("gradgrind.mcom.com" "gradgrind")
     (remote-command-line 'telnet-connect)
     (remote-user "drush"))
    ))
     
(defvar mirror-remote-command-line-method 'mirror-telnet-connect)
(defvar mirror-rsh-program "ssh")

;;; accessors

;;; internal vars
(defconst mirror-name "*Mirror*" "Low Bandwidth")
(defconst cg-debug-buffer "*mirror debug*"
  "*buffer for seeing what is sent to the host")
(defconst cg-debug-send t "Send to process?")




(defun mirror-buffer ()
  (let ((b (get-buffer-create mirror-name)))
    (erase-buffer b)
    b))


(defun mirror-net-send (cxn s)
  (if mirror-debug-buffer
      (save-excursion
	(let ((buffer (get-buffer-create cg-debug-buffer)))
	  (set-buffer buffer)
	  (goto-char (point-max))
	  (if (stringp s) (insert s)
	    (insert (format "Wrote contents of buffer: %S\n" s))))))
  (if mirror-debug-send
      (if (bufferp s)
	  (save-excursion
	    (set-buffer s)
	    (process-send-region cxn (point-min s) (point-max s)))
	  (process-send-string cxn s))))


(provide 'mirror-net)